/*
Version: 0.91
Date: 25/02/05
*/

#ifndef AVI_H
#define AVI_H

#include <iostream>
#include <fstream>
#include <string.h>
#include <memory.h>

#include "defs.h"

template<class T>
inline T SWAP_BYTE_ORDER(T v) {
	union {
		T n;
		byte b[sizeof(T)];
	} sw;

	for(int i = 0; i < sizeof(T); ++i) {
		sw.b[i] = (byte)(v>>(8*i)) & 0xFF;
	}

	return sw.n;
}

class avi {
public:
	uint height;
	uint width;
	uint frames;

	double fps;

	char* name;

	avi(char* filename);
	~avi();

	void read_video();
	void write_video(uint in_frames,uint in_width,uint in_height,double in_fps);

	frame get_frame(uint index);
	void write_frame(uint index,frame& image);

private:
	long* fileoffset;
	FILE* moviefile;
};

#endif // AVI_H
