#include "color.h"

//=============================================================================
// rgb2grey
//=============================================================================
// conversie van RGB waarden naar grijswaarden
//=============================================================================
double rgb2grey(rgb value) {
	return (0.2990*value.red + 0.5870*value.green + 0.1140*value.blue);
}

//=============================================================================
// rgb2luminance
//=============================================================================
// conversie van RGB waarden naar CIELab luminantiewaarden
//=============================================================================
double rgb2luminance(rgb value) {
	// CIELab luminance
	double result,y;
	rgb temp = value/255.0;

	if (temp.red > 0.04045) {
		temp.red = pow(((temp.red + 0.055)/1.055),2.4);
	} else {
		temp.red /= 12.92;
	}
	if (temp.green > 0.04045) {
		temp.green = pow(((temp.green + 0.055)/1.055),2.4);
	} else {
		temp.green /= 12.92;
	}
	if (temp.blue > 0.04045) {
		temp.blue = pow(((temp.blue + 0.055)/1.055),2.4);
	} else {
		temp.blue /= 12.92;
	}

	y = temp.red*0.212671 + temp.green*0.715160 + temp.blue*0.072169;

	if (y > 0.008856) {
		y = pow(y,(1.0/3.0));
	} else {
		y = 7.787*y + 16.0/116.0;
	}

	result = 116.0*y - 16.0;

	return result;
}
